require 'digest/md5'
module MysqlerTemplateHelpers
  def db_user(user_id, access_type = "rw")
    user = user_base(user_id) + "_" + access_type
    Chef::Log.debug("User #{user} generated by MysqlerTemplateHelpers")
    user
  end

  def db_pass(user_id, access_type = "rw")
    Chef::Log.debug("Password for user_id #{user_id} generated by MysqlerTemplateHelpers")
    Digest::MD5.hexdigest(
      db_user(user_id, access_type) + node['mysqler']['salt'] 
    )
  end

  private
  def user_base(user_id)
    user_id
  end
end

class Erubis::Context
  include MysqlerTemplateHelpers unless Erubis::Context.instance_methods.include?(:db_user)
end

class Chef::Recipe
  include MysqlerTemplateHelpers unless Chef::Recipe.instance_methods.include?(:db_user)
end
